<?php

require_once('/usr/local/www/berogui/includes/isgwtelnet.php');

class CellBroadcastMessageService {

	private		$_isgw,
			$_error,
			$_errorMessage;

	function __construct ()  {

		$this->_error = false;
		$this->_errorMessage = '';

		$this->_isgw = new isgwtelnet();
		if ($this->_isgw->isgw_login() == false) {
			$this->_error = true;
			$this->_errorMessage = 'Connection refused by ISGW';
		}

		foreach (array('in', 'partial') as $folder) {
			if (!file_exists('/tmp/cbm/' . $folder)) {
				@exec('/bin/mkdir -p /tmp/cbm/' . $folder);
			}
		}
	}

	public function getErrorText () {
		return(($this->_error = true) ? $this->_errorMessage : false);
	}


	public function listMessages ($queueName) {

		if (!in_array($queueName, array('in', 'parts'))) {
			return(null);
		}

		if (($dp = @opendir('/tmp/cbm/' . $queueName)) == null) {
			return(null);
		}

		$ret = array();
		while (($file = readdir($dp)) !== false) {
			if (($file == '.') || ($file == '..')) {
				continue;
			}

			if ($queueName == 'lists') {
				$ret[] = $file;
				continue;
			}

			if (preg_match('/.*\.cbm$/', $file)) {
				$ret[] = basename($file, '.cbm');
			}
		}

		return($ret);
	}

	public function getMessage ($queueName, $smsId) {

		if (!in_array($queueName, array('in', 'parts'))) {
			return(null);
		}

		switch ($queueName) {
		case 'in':
			$smsFile = '/tmp/cbm/' . $queueName . '/' . $smsId . '.cbm';
			$ret['message'] = (!file_exists($smsFile)) ? 'Message not found' : @file_get_contents($smsFile);
			break;
		case 'parts':
			$smsFile = '/tmp/cbm/' . $queueName . '/' . $smsId . '.cbm';
			$ret['message'] = (!file_exists($smsFile)) ? 'Message not found' : @file_get_contents($smsFile);
			$ret['log'] = (!file_exists($smsFile . '.log')) ? '' : @file_get_contents($smsFile . '.log');
			break;
		}

		return($ret);
	}

	public function deleteMessage ($queueName, $smsId) {

		if (!in_array($queueName, array('in', 'out', 'failout'))) {
			return;
		}

		switch ($queueName) {
		case 'in':
			@unlink('/tmp/cbm/' . $queueName . '/' . $smsId . '.cbm');
			break;
		case 'out':
			@unlink('/tmp/cbm/' . $queueName . '/' . $smsId . '.cbm');
			@unlink('/tmp/cbm/' . $queueName . '/' . $smsId . '.cbm.log');
			break;
		case 'parts':
			@unlink('/tmp/cbm/' . $queueName . '/' . $smsId . '/message');
			@unlink('/tmp/cbm/' . $queueName . '/' . $smsId . '/message.log');
			@rmdir('/tmp/cbm/' . $queueName . '/' . $smsId);
			break;
		}
	}


}
?>
